Index: /palm/trunk/SOURCE/restart_data_mpi_io_mod.f90
===================================================================
--- /palm/trunk/SOURCE/restart_data_mpi_io_mod.f90	(revision 4590)
+++ /palm/trunk/SOURCE/restart_data_mpi_io_mod.f90	(revision 4591)
@@ -1251,5 +1301,5 @@
        ENDDO
 #if defined( __parallel )
-       CALL sm_io%sm_node_barrier()  ! has no effect if I/O on limited number of cores is inactive
+       CALL sm_io%sm_node_barrier()  ! Has no effect if I/O on limited number of cores is inactive
        IF ( sm_io%iam_io_pe )  THEN
           CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_INTEGER, ft_2di_nb, 'native',            &
@@ -1289,11 +1339,11 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)       ::  name
-
-    INTEGER(iwp)                       ::  i
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size) ::  status
-#endif
-    REAL(wp), INTENT(IN), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  ::  data
+    CHARACTER(LEN=*), INTENT(IN)       ::  name    !<
+
+    INTEGER(iwp)                       ::  i       !<
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size) ::  status  !<
+#endif
+    REAL(wp), INTENT(IN), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  data !<
 
 
@@ -1308,9 +1358,8 @@
     IF ( include_total_domain_boundaries )  THEN
 !
-!--    Prepare output of 3d-REAL-array with ghost layers.
-!--    In the virtual PE grid, the first dimension is PEs along x, and the second along y.
-!--    For MPI-IO it is recommended to have the index order of the array in the same way, i.e.
-!--    the first dimension should be along x and the second along y.
-!--    For this reason, the original PALM data need to be swaped.
+!--    Prepare output of 3d-REAL-array with ghost layers. In the virtual PE grid, the first
+!--    dimension is PEs along x, and the second along y. For MPI-IO it is recommended to have the
+!--    index order of the array in the same way, i.e. the first dimension should be along x and the
+!--    second along y. For this reason, the original PALM data need to be swaped.
        DO  i = lb%nxl, lb%nxr
           array_3d(:,i,lb%nys:lb%nyn) = data(:,lb%nys-nbgp:lb%nyn-nbgp,i-nbgp)
@@ -1326,5 +1375,5 @@
     ENDIF
 #if defined( __parallel )
-    CALL sm_io%sm_node_barrier()  ! has no effect if I/O on limited number of cores is inactive
+    CALL sm_io%sm_node_barrier()  ! Has no effect if I/O on limited number of cores is inactive
     IF ( sm_io%iam_io_pe )  THEN
        CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_REAL, ft_3d, 'native', MPI_INFO_NULL, ierr )
@@ -1337,9 +1386,9 @@
 #endif
 !
-!-- Type conversion required, otherwise rigth hand side brackets are calculated assuming 4 byte INT.
+!-- Type conversion required, otherwise right hand side brackets are calculated assuming 4 byte INT.
 !-- Maybe a compiler problem.
-    array_position = array_position + INT(    (nz+2), KIND=rd_offset_kind ) *                      &
-                                      INT( (lb%ny+1), KIND=rd_offset_kind ) *                      &
-                                      INT( (lb%nx+1), KIND=rd_offset_kind ) * wp
+    array_position = array_position + INT(    (nz+2), KIND = rd_offset_kind ) *                    &
+                                      INT( (lb%ny+1), KIND = rd_offset_kind ) *                    &
+                                      INT( (lb%nx+1), KIND = rd_offset_kind ) * wp
 
  END SUBROUTINE wrd_mpi_io_real_3d
@@ -1358,15 +1407,15 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)       ::  name
-
-    INTEGER(iwp)                       ::  i
-    INTEGER, INTENT(IN)                ::  nzb_soil
-    INTEGER, INTENT(IN)                ::  nzt_soil
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size) ::  status
-#endif
-
-    REAL(wp), INTENT(IN), DIMENSION(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg)  ::  data
+    CHARACTER(LEN=*), INTENT(IN)       ::  name      !<
+
+    INTEGER(iwp)                       ::  i         !<
+    INTEGER, INTENT(IN)                ::  nzb_soil  !<
+    INTEGER, INTENT(IN)                ::  nzt_soil  !<
+
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size) ::  status  !<
+#endif
+
+    REAL(wp), INTENT(IN), DIMENSION(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) ::  data  !<
 
 
@@ -1385,9 +1434,8 @@
     IF ( include_total_domain_boundaries)  THEN
 !
-!--    Prepare output of 3d-REAL-array with ghost layers.
-!--    In the virtual PE grid, the first dimension is PEs along x, and the second along y.
-!--    For MPI-IO it is recommended to have the index order of the array in the same way, i.e.
-!--    the first dimension should be along x and the second along y.
-!--    For this reason, the original PALM data need to be swaped.
+!--    Prepare output of 3d-REAL-array with ghost layers. In the virtual PE grid, the first
+!--    dimension is PEs along x, and the second along y. For MPI-IO it is recommended to have the
+!--    index order of the array in the same way, i.e. the first dimension should be along x and the
+!--    second along y. For this reason, the original PALM data need to be swaped.
        DO  i = lb%nxl, lb%nxr
           array_3d_soil(:,i,lb%nys:lb%nyn) = data(:,lb%nys-nbgp:lb%nyn-nbgp,i-nbgp)
@@ -1403,5 +1451,5 @@
     ENDIF
 #if defined( __parallel )
-    CALL sm_io%sm_node_barrier()  ! has no effect if I/O on limited number of cores is inactive
+    CALL sm_io%sm_node_barrier()  ! Has no effect if I/O on limited number of cores is inactive
     IF ( sm_io%iam_io_pe )  THEN
        CALL MPI_FILE_SET_VIEW( fh, array_position, MPI_REAL, ft_3dsoil, 'native', MPI_INFO_NULL,   &
@@ -1415,9 +1463,9 @@
 #endif
 !
-!-- Type conversion required, otherwise rigth hand side brackets are calculated assuming 4 byte INT.
+!-- Type conversion required, otherwise right hand side brackets are calculated assuming 4 byte INT.
 !-- Maybe a compiler problem.
-    array_position = array_position + INT( (nzt_soil-nzb_soil+1), KIND=rd_offset_kind ) *          &
-                                      INT( (lb%ny+1),             KIND=rd_offset_kind ) *          &
-                                      INT( (lb%nx+1),             KIND=rd_offset_kind ) * wp
+    array_position = array_position + INT( (nzt_soil-nzb_soil+1), KIND = rd_offset_kind ) *        &
+                                      INT( (lb%ny+1),             KIND = rd_offset_kind ) *        &
+                                      INT( (lb%nx+1),             KIND = rd_offset_kind ) * wp
 
  END SUBROUTINE wrd_mpi_io_real_3d_soil
@@ -1434,7 +1482,7 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=128)           ::  lo_line
-    CHARACTER(LEN=*), INTENT(IN) ::  name
-    CHARACTER(LEN=*), INTENT(IN) ::  text
+    CHARACTER(LEN=128)           ::  lo_line  !<
+    CHARACTER(LEN=*), INTENT(IN) ::  name     !<
+    CHARACTER(LEN=*), INTENT(IN) ::  text     !<
 
 
@@ -1461,9 +1509,9 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN) ::  name
-
-    INTEGER(iwp)                 ::  logical_as_integer
-
-    LOGICAL, INTENT(IN)          ::  value
+    CHARACTER(LEN=*), INTENT(IN) ::  name                !<
+
+    INTEGER(iwp)                 ::  logical_as_integer  !<
+
+    LOGICAL, INTENT(IN)          ::  value               !<
 
 
@@ -1490,16 +1538,16 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)       ::  name
-
-    INTEGER(iwp)                       ::  i
-    INTEGER(KIND=rd_offset_kind)       ::  offset
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size) ::  status
-#endif
-
-    LOGICAL                            ::  found
-
-    REAL(KIND=wp), INTENT(INOUT), DIMENSION(:) ::  data
+    CHARACTER(LEN=*), INTENT(IN)       ::  name    !<
+
+    INTEGER(iwp)                       ::  i       !<
+    INTEGER(KIND=rd_offset_kind)       ::  offset  !<
+
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size) ::  status  !<
+#endif
+
+    LOGICAL                            ::  found   !<
+
+    REAL(KIND=wp), INTENT(INOUT), DIMENSION(:) ::  data  !<
 
 
@@ -1525,5 +1573,5 @@
        ENDIF
        IF ( sm_io%is_sm_active() )  THEN
-          CALL MPI_BCAST( data, SIZE(data), MPI_REAL, 0, sm_io%comm_shared, ierr )
+          CALL MPI_BCAST( data, SIZE( data ), MPI_REAL, 0, sm_io%comm_shared, ierr )
        ENDIF
 #else
@@ -1554,12 +1602,12 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)                      ::  name
-
-    INTEGER, DIMENSION(1)                             ::  bufshape
-
-    REAL(KIND=wp), INTENT(IN), DIMENSION(:,:), TARGET ::  data
-    REAL(KIND=wp), POINTER, DIMENSION(:)              ::  buf
-
-    TYPE(C_PTR)                                       ::  c_data
+    CHARACTER(LEN=*), INTENT(IN)                      ::  name      !<
+
+    INTEGER, DIMENSION(1)                             ::  bufshape  !<
+
+    REAL(KIND=wp), INTENT(IN), DIMENSION(:,:), TARGET ::  data      !<
+    REAL(KIND=wp), POINTER, DIMENSION(:)              ::  buf       !<
+
+    TYPE(C_PTR)                                       ::  c_data    !<
 
 
@@ -1584,12 +1632,12 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)                        ::  name
-
-    INTEGER, DIMENSION(1)                               ::  bufshape
-
-    REAL(KIND=wp), INTENT(IN), DIMENSION(:,:,:), TARGET ::  data
-    REAL(KIND=wp), POINTER, DIMENSION(:)                ::  buf
-
-    TYPE(C_PTR)                                         ::  c_data
+    CHARACTER(LEN=*), INTENT(IN)                        ::  name      !<
+
+    INTEGER, DIMENSION(1)                               ::  bufshape  !<
+
+    REAL(KIND=wp), INTENT(IN), DIMENSION(:,:,:), TARGET ::  data      !<
+    REAL(KIND=wp), POINTER, DIMENSION(:)                ::  buf       !<
+
+    TYPE(C_PTR)                                         ::  c_data    !<
 
 
@@ -1614,12 +1662,12 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)                          ::  name
-
-    INTEGER, DIMENSION(1)                                 ::  bufshape
-
-    REAL(KIND=wp), INTENT(IN), DIMENSION(:,:,:,:), TARGET ::  data
-    REAL(KIND=wp), POINTER, DIMENSION(:)                  ::  buf
-
-    TYPE(C_PTR)                                           ::  c_data
+    CHARACTER(LEN=*), INTENT(IN)                          ::  name      !<
+
+    INTEGER, DIMENSION(1)                                 ::  bufshape  !<
+
+    REAL(KIND=wp), INTENT(IN), DIMENSION(:,:,:,:), TARGET ::  data      !<
+    REAL(KIND=wp), POINTER, DIMENSION(:)                  ::  buf       !<
+
+    TYPE(C_PTR)                                           ::  c_data    !<
 
 
@@ -1644,15 +1692,15 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)                   ::  name
-
-    INTEGER(iwp)                                   ::  i
-    INTEGER(KIND=rd_offset_kind)                   ::  offset
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size)             ::  status
-#endif
-    INTEGER(KIND=iwp), INTENT(INOUT), DIMENSION(:) ::  data
-
-    LOGICAL                                        ::  found
+    CHARACTER(LEN=*), INTENT(IN)                   ::  name    !<
+
+    INTEGER(iwp)                                   ::  i       !<
+    INTEGER(KIND=rd_offset_kind)                   ::  offset  !<
+
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size)             ::  status  !<
+#endif
+    INTEGER(KIND=iwp), INTENT(INOUT), DIMENSION(:) ::  data    !<
+
+    LOGICAL                                        ::  found   !<
 
 
@@ -1661,5 +1709,5 @@
 
     DO  i = 1, tgh%nr_arrays
-       IF ( TRIM(array_names(i)) == TRIM( name ) )  THEN
+       IF ( TRIM( array_names(i) ) == TRIM( name ) )  THEN
           array_position = array_offset(i)
           found = .TRUE.
@@ -1678,5 +1726,5 @@
        ENDIF
        IF ( sm_io%is_sm_active() )  THEN
-          CALL MPI_BCAST( data, SIZE(data), MPI_INTEGER, 0, sm_io%comm_shared, ierr )
+          CALL MPI_BCAST( data, SIZE( data ), MPI_INTEGER, 0, sm_io%comm_shared, ierr )
        ENDIF
 #else
@@ -1706,13 +1754,13 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)            ::  name
-
-    INTEGER(KIND=rd_offset_kind)            ::  offset
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size)      ::  status
-#endif
-
-    REAL(KIND=wp), INTENT(IN), DIMENSION(:) ::  data
+    CHARACTER(LEN=*), INTENT(IN)            ::  name    !<
+
+    INTEGER(KIND=rd_offset_kind)            ::  offset  !<
+
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size)      ::  status  !<
+#endif
+
+    REAL(KIND=wp), INTENT(IN), DIMENSION(:) ::  data    !<
 
 
@@ -1737,5 +1785,5 @@
     IF ( myid == 0 )  THEN
        CALL MPI_FILE_SEEK( fh, array_position, MPI_SEEK_SET, ierr )
-       CALL MPI_FILE_WRITE( fh, data, SIZE( data), MPI_REAL, status, ierr )
+       CALL MPI_FILE_WRITE( fh, data, SIZE( data ), MPI_REAL, status, ierr )
     ENDIF
 #else
@@ -1759,12 +1807,12 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)                      ::  name
-
-    INTEGER, DIMENSION(1)                             ::  bufshape
-
-    REAL(KIND=wp), POINTER, DIMENSION(:)              ::  buf
-    REAL(KIND=wp), INTENT(IN), DIMENSION(:,:), TARGET ::  data
-
-    TYPE(C_PTR)                                       ::  c_data
+    CHARACTER(LEN=*), INTENT(IN)                      ::  name      !<
+
+    INTEGER, DIMENSION(1)                             ::  bufshape  !<
+
+    REAL(KIND=wp), POINTER, DIMENSION(:)              ::  buf       !<
+    REAL(KIND=wp), INTENT(IN), DIMENSION(:,:), TARGET ::  data      !<
+
+    TYPE(C_PTR)                                       ::  c_data    !<
 
 
@@ -1789,12 +1837,12 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)                        ::  name
-
-    INTEGER, DIMENSION(1)                               ::  bufshape
-
-    REAL(KIND=wp), POINTER, DIMENSION(:)                ::  buf
-    REAL(KIND=wp), INTENT(IN), DIMENSION(:,:,:), TARGET ::  data
-
-    TYPE(C_PTR)                                         ::  c_data
+    CHARACTER(LEN=*), INTENT(IN)                        ::  name      !<
+
+    INTEGER, DIMENSION(1)                               ::  bufshape  !<
+
+    REAL(KIND=wp), POINTER, DIMENSION(:)                ::  buf       !<
+    REAL(KIND=wp), INTENT(IN), DIMENSION(:,:,:), TARGET ::  data      !<
+
+    TYPE(C_PTR)                                         ::  c_data    !<
 
 
@@ -1819,12 +1867,12 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)                          ::  name
-
-    INTEGER, DIMENSION(1)                                 ::  bufshape
-
-    REAL(KIND=wp), POINTER, DIMENSION(:)                  ::  buf
-    REAL(KIND=wp), INTENT(IN), DIMENSION(:,:,:,:), TARGET ::  data
-
-    TYPE(C_PTR)                                           ::  c_data
+    CHARACTER(LEN=*), INTENT(IN)                          ::  name      !<
+
+    INTEGER, DIMENSION(1)                                 ::  bufshape  !<
+
+    REAL(KIND=wp), POINTER, DIMENSION(:)                  ::  buf       !<
+    REAL(KIND=wp), INTENT(IN), DIMENSION(:,:,:,:), TARGET ::  data      !<
+
+    TYPE(C_PTR)                                           ::  c_data    !<
 
 
@@ -1849,11 +1897,11 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)                ::  name
-
-    INTEGER(KIND=rd_offset_kind)                ::  offset
-
-    INTEGER(KIND=iwp), INTENT(IN), DIMENSION(:) ::  data
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size)          ::  status
+    CHARACTER(LEN=*), INTENT(IN)                ::  name    !<
+
+    INTEGER(KIND=rd_offset_kind)                ::  offset  !<
+
+    INTEGER(KIND=iwp), INTENT(IN), DIMENSION(:) ::  data    !<
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size)          ::  status  !<
 #endif
 
@@ -1875,5 +1923,5 @@
 !
 !-- Only PE 0 writes replicated data
-    IF ( myid == 0 )  THEN                        ! 
+    IF ( myid == 0 )  THEN
        CALL MPI_FILE_SEEK( fh, array_position, MPI_SEEK_SET, ierr )
        CALL MPI_FILE_WRITE( fh, data, SIZE( data), MPI_INTEGER, status, ierr )
@@ -1898,26 +1946,26 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN) ::  name
-
-    INTEGER(KIND=rd_offset_kind) ::  disp          !< displacement of actual indices
-    INTEGER(KIND=rd_offset_kind) ::  disp_f        !< displacement in file
-    INTEGER(KIND=rd_offset_kind) ::  disp_n        !< displacement of next column
-    INTEGER(iwp), OPTIONAL       ::  first_index
-
-    INTEGER(iwp)                 ::  i
-    INTEGER(iwp)                 ::  i_f
-    INTEGER(iwp)                 ::  j
-    INTEGER(iwp)                 ::  j_f
-    INTEGER(iwp)                 ::  lo_first_index
-    INTEGER(iwp)                 ::  nr_bytes
-    INTEGER(iwp)                 ::  nr_bytes_f
-    INTEGER(iwp)                 ::  nr_words
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size)  ::  status
-#endif
-
-    LOGICAL                             ::  found
-
-    REAL(wp), INTENT(OUT), DIMENSION(:) ::  data
+    CHARACTER(LEN=*), INTENT(IN) ::  name            !<
+
+    INTEGER(KIND=rd_offset_kind) ::  disp            !< displacement of actual indices
+    INTEGER(KIND=rd_offset_kind) ::  disp_f          !< displacement in file
+    INTEGER(KIND=rd_offset_kind) ::  disp_n          !< displacement of next column
+    INTEGER(iwp), OPTIONAL       ::  first_index     !<
+
+    INTEGER(iwp)                 ::  i               !<
+    INTEGER(iwp)                 ::  i_f             !<
+    INTEGER(iwp)                 ::  j               !<
+    INTEGER(iwp)                 ::  j_f             !<
+    INTEGER(iwp)                 ::  lo_first_index  !<
+    INTEGER(iwp)                 ::  nr_bytes        !<
+    INTEGER(iwp)                 ::  nr_bytes_f      !<
+    INTEGER(iwp)                 ::  nr_words        !<
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size)  ::  status   !<
+#endif
+
+    LOGICAL                             ::  found    !<
+
+    REAL(wp), INTENT(OUT), DIMENSION(:) ::  data     !<
 
 
@@ -1925,5 +1973,5 @@
     lo_first_index = 1
 
-    IF ( MAXVAL( m_global_start ) == -1 )   RETURN   ! nothing to do on this PE
+    IF ( MAXVAL( m_global_start ) == -1 )   RETURN   ! Nothing to do on this PE
 
     IF ( PRESENT( first_index ) )   THEN
@@ -1934,5 +1982,5 @@
         IF ( TRIM( array_names(i) ) == TRIM( name ) )  THEN
            array_position = array_offset(i) + ( lo_first_index - 1 ) *                             &
-                                              total_number_of_surface_values * wp
+                            total_number_of_surface_values * wp
            found = .TRUE.
            EXIT
@@ -1953,5 +2001,5 @@
                 nr_bytes = nr_words * wp
              ENDIF
-             IF ( disp >= 0  .AND.  disp_f == -1 )  THEN   ! first Entry
+             IF ( disp >= 0  .AND.  disp_f == -1 )  THEN   ! First entry
                 disp_f     = disp
                 nr_bytes_f = 0
@@ -1959,10 +2007,10 @@
                 j_f = j
              ENDIF
-             IF ( j == nyn  .AND.  i == nxr )  THEN        ! last Entry
+             IF ( j == nyn  .AND.  i == nxr )  THEN        ! Last entry
                 disp_n = -1
                 IF (  nr_bytes > 0 )  THEN
                    nr_bytes_f = nr_bytes_f+nr_bytes
                 ENDIF
-             ELSEIF ( j == nyn )  THEN                     ! next x
+             ELSEIF ( j == nyn )  THEN                     ! Next x
                 IF ( m_global_start(nys,i+1) > 0  .AND.  disp > 0 )  THEN
                    disp_n = array_position + ( m_global_start(nys,i+1) - 1 ) * wp
@@ -1979,11 +2027,12 @@
 
 
-             IF ( disp + nr_bytes == disp_n )  THEN        ! contiguous block
+             IF ( disp + nr_bytes == disp_n )  THEN        ! Contiguous block
                 nr_bytes_f = nr_bytes_f + nr_bytes
-             ELSE                                          ! read
+             ELSE                                          ! Read
 #if defined( __parallel )
                 CALL MPI_FILE_SEEK( fhs, disp_f, MPI_SEEK_SET, ierr )
                 nr_words = nr_bytes_f / wp
-                CALL MPI_FILE_READ( fhs, data(m_start_index(j_f,i_f)), nr_words, MPI_REAL, status, ierr )
+                CALL MPI_FILE_READ( fhs, data(m_start_index(j_f,i_f)), nr_words, MPI_REAL, status, &
+                                    ierr )
 #else
                 CALL posix_lseek( fh, disp_f )
@@ -2027,13 +2076,13 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)          ::  name
-
-    INTEGER(iwp)                          ::  i
-
-    REAL(wp), INTENT(OUT), DIMENSION(:,:) ::  data
-    REAL(wp), DIMENSION(SIZE( data,2))    ::  tmp
-
-
-    DO  i = 1, SIZE( data,1)
+    CHARACTER(LEN=*), INTENT(IN)          ::  name  !<
+
+    INTEGER(iwp)                          ::  i     !<
+
+    REAL(wp), INTENT(OUT), DIMENSION(:,:) ::  data  !<
+    REAL(wp), DIMENSION(SIZE( data,2))    ::  tmp   !<
+
+
+    DO  i = 1, SIZE( data, 1 )
        CALL rrd_mpi_io_surface( name, tmp, first_index = i )
        data(i,:) = tmp
@@ -2042,11 +2091,10 @@
 !
 !-- Comment from Klaus Ketelsen (September 2018)
-!-- The intention of the following loop was let the compiler do the copying on return.
-!-- In my understanding is it standard conform to pass the second dimension to a 1d-
-!-- array inside a subroutine and the compiler is responsible to generate code for
-!-- copying. Acually this works fine for INTENT(IN) variables (wrd_mpi_io_surface_2d).
-!-- For INTENT(OUT) like in this case the code works on pgi compiler. But both, the Intel 16
-!-- and the Cray compiler show wrong answers using this loop.
-!-- That is the reason why the above auxiliary array tmp was introduced.
+!-- The intention of the following loop was to let the compiler do the copying on return.
+!-- In my understanding it is standard conform to pass the second dimension to a 1d-array inside a
+!-- subroutine and the compiler is responsible to generate code for copying. Acually this works fine
+!-- for INTENT(IN) variables (wrd_mpi_io_surface_2d). For INTENT(OUT) like in this case the code
+!-- works on pgi compiler. But both, the Intel 16 and the Cray compiler show wrong answers using
+!-- this loop. That is the reason why the above auxiliary array tmp was introduced.
 !    DO  i = 1, SIZE(  data,1)
 !       CALL rrd_mpi_io_surface( name, data(i,:), first_index = i )
@@ -2066,21 +2114,21 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)       ::  name
-
-#if defined( __parallel )
-    INTEGER(KIND=rd_offset_kind)       ::  disp
-#endif
-    INTEGER(iwp), OPTIONAL             ::  first_index
-#if defined( __parallel )
-    INTEGER(iwp)                       ::  i
-#endif
-    INTEGER(iwp)                       ::  lo_first_index
-    INTEGER(KIND=rd_offset_kind)       ::  offset
-
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size) ::  status
-#endif
-
-    REAL(wp), INTENT(IN), DIMENSION(:), TARGET ::  data
+    CHARACTER(LEN=*), INTENT(IN)       ::  name            !<
+
+#if defined( __parallel )
+    INTEGER(KIND=rd_offset_kind)       ::  disp            !<
+#endif
+    INTEGER(iwp), OPTIONAL             ::  first_index     !<
+#if defined( __parallel )
+    INTEGER(iwp)                       ::  i               !<
+#endif
+    INTEGER(iwp)                       ::  lo_first_index  !<
+    INTEGER(KIND=rd_offset_kind)       ::  offset          !<
+
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size) ::  status          !<
+#endif
+
+    REAL(wp), INTENT(IN), DIMENSION(:), TARGET ::  data    !<
 
 
@@ -2088,5 +2136,5 @@
     lo_first_index = 1
 
-    IF ( PRESENT(first_index) )  THEN
+    IF ( PRESENT( first_index ) )  THEN
        lo_first_index = first_index
     ENDIF
@@ -2116,5 +2164,5 @@
     ENDIF
 
-    CALL sm_io%sm_node_barrier()  ! has no effect if I/O on limited number of cores is inactive
+    CALL sm_io%sm_node_barrier()  ! Has no effect if I/O on limited number of cores is inactive
     IF ( sm_io%iam_io_pe )  THEN
        IF ( all_pes_write )  THEN
@@ -2154,5 +2202,5 @@
 ! ------------
 !> Read 2d-REAL surface data array with MPI-IO.
-!> These consist of multiple 1d-REAL surface data arrays.
+!> This consist of multiple 1d-REAL surface data arrays.
 !--------------------------------------------------------------------------------------------------!
  SUBROUTINE wrd_mpi_io_surface_2d( name, data )
@@ -2160,12 +2208,12 @@
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN)         ::  name
-
-    INTEGER(iwp)                         ::  i
-
-    REAL(wp), INTENT(IN), DIMENSION(:,:) ::  data
-
-
-    DO  i = 1, SIZE( data,1)
+    CHARACTER(LEN=*), INTENT(IN)         ::  name  !<
+
+    INTEGER(iwp)                         ::  i     !<
+
+    REAL(wp), INTENT(IN), DIMENSION(:,:) ::  data  !<
+
+
+    DO  i = 1, SIZE( data, 1 )
        CALL wrd_mpi_io_surface( name, data(i,:), first_index = i )
     ENDDO
@@ -2184,12 +2232,12 @@
     IMPLICIT NONE
 
-    INTEGER(iwp)                       ::  gh_size
-    INTEGER(KIND=rd_offset_kind)       ::  offset
-#if defined( __parallel )
-    INTEGER, DIMENSION(rd_status_size) ::  status
+    INTEGER(iwp)                       ::  gh_size  !<
+    INTEGER(KIND=rd_offset_kind)       ::  offset   !<
+#if defined( __parallel )
+    INTEGER, DIMENSION(rd_status_size) ::  status   !<
 #endif
 
 #if ! defined( __parallel )
-    TYPE(C_PTR)                        ::  buf_ptr
+    TYPE(C_PTR)                        ::  buf_ptr  !<
 #endif
 
@@ -2205,6 +2253,6 @@
        tgh%total_nx  = lb%nx + 1
        tgh%total_ny  = lb%ny + 1
-       IF ( include_total_domain_boundaries )  THEN   ! not sure, if LOGICAL interpretation is the same for all compilers,
-          tgh%i_outer_bound = 1        ! therefore store as INTEGER in general header
+       IF ( include_total_domain_boundaries )  THEN   ! Not sure, if LOGICAL interpretation is the same for all compilers,
+          tgh%i_outer_bound = 1                       ! therefore store as INTEGER in general header
        ELSE
           tgh%i_outer_bound = 0
@@ -2231,5 +2279,5 @@
 !--       INTEGER values
           CALL MPI_FILE_SEEK( fh, header_position, MPI_SEEK_SET, ierr )
-          CALL MPI_FILE_WRITE( fh, int_names, SIZE( int_names )*32, MPI_CHAR, status, ierr )
+          CALL MPI_FILE_WRITE( fh, int_names, SIZE( int_names ) * 32, MPI_CHAR, status, ierr )
           header_position = header_position + SIZE( int_names ) * 32
 
@@ -2240,10 +2288,10 @@
 !--       Character entries
           CALL MPI_FILE_SEEK( fh, header_position, MPI_SEEK_SET, ierr )
-          CALL MPI_FILE_WRITE( fh, text_lines, SIZE( text_lines )*128, MPI_CHAR, status, ierr )
+          CALL MPI_FILE_WRITE( fh, text_lines, SIZE( text_lines ) * 128, MPI_CHAR, status, ierr )
           header_position = header_position + SIZE( text_lines ) * 128
 !
 !---      REAL values
           CALL MPI_FILE_SEEK( fh, header_position, MPI_SEEK_SET, ierr )
-          CALL MPI_FILE_WRITE( fh, real_names, SIZE( real_names )*32, MPI_CHAR, status, ierr )
+          CALL MPI_FILE_WRITE( fh, real_names, SIZE( real_names ) * 32, MPI_CHAR, status, ierr )
           header_position = header_position + SIZE( real_names ) * 32
 
@@ -2254,9 +2302,9 @@
 !--       2d- and 3d- distributed array headers, all replicated array headers
           CALL MPI_FILE_SEEK( fh, header_position, MPI_SEEK_SET, ierr )
-          CALL MPI_FILE_WRITE( fh, array_names, SIZE( array_names )*32, MPI_CHAR, status, ierr )
+          CALL MPI_FILE_WRITE( fh, array_names, SIZE( array_names ) * 32, MPI_CHAR, status, ierr )
           header_position = header_position + SIZE( array_names ) * 32
 
           CALL MPI_FILE_SEEK( fh, header_position, MPI_SEEK_SET, ierr )
-          CALL MPI_FILE_WRITE( fh, array_offset, SIZE( array_offset )*MPI_OFFSET_KIND, MPI_BYTE,   &
+          CALL MPI_FILE_WRITE( fh, array_offset, SIZE( array_offset ) * MPI_OFFSET_KIND, MPI_BYTE, &
                                status, ierr )  ! There is no I*8 datatype in Fortran
           header_position = header_position + SIZE( array_offset ) * rd_offset_kind
@@ -2350,18 +2398,20 @@
     IMPLICIT NONE
 
-    INTEGER(iwp)                          ::  i            !<  loop index
-    INTEGER(KIND=rd_offset_kind)          ::  offset
-
-    INTEGER(iwp), DIMENSION(1)            ::  dims1
-    INTEGER(iwp), DIMENSION(1)            ::  lize1
-    INTEGER(iwp), DIMENSION(1)            ::  start1
-    INTEGER(iwp), DIMENSION(0:numprocs-1) ::  lo_nr_val    !< local number of values in x and y direction
-    INTEGER(iwp), DIMENSION(0:numprocs-1) ::  all_nr_val   !< number of values for all PEs
-
-    INTEGER, INTENT(IN), DIMENSION(nys:nyn,nxl:nxr)  ::  end_index
-    INTEGER, INTENT(OUT), DIMENSION(nys:nyn,nxl:nxr) ::  global_start
-    INTEGER, INTENT(IN), DIMENSION(nys:nyn,nxl:nxr)  ::  start_index
-
-    LOGICAL, INTENT(OUT)                  ::  data_to_write  !< returns, if surface data have to be written
+    INTEGER(iwp)                          ::  i           !<  loop index
+    INTEGER(KIND=rd_offset_kind)          ::  offset      !<
+
+    INTEGER(iwp), DIMENSION(1)            ::  dims1       !<
+    INTEGER(iwp), DIMENSION(1)            ::  lize1       !<
+    INTEGER(iwp), DIMENSION(1)            ::  start1      !<
+
+    INTEGER(iwp), DIMENSION(0:numprocs-1) ::  all_nr_val  !< number of values for all PEs
+    INTEGER(iwp), DIMENSION(0:numprocs-1) ::  lo_nr_val   !< local number of values in x and y direction
+
+
+    INTEGER, INTENT(IN), DIMENSION(nys:nyn,nxl:nxr)  ::  end_index     !<
+    INTEGER, INTENT(OUT), DIMENSION(nys:nyn,nxl:nxr) ::  global_start  !<
+    INTEGER, INTENT(IN), DIMENSION(nys:nyn,nxl:nxr)  ::  start_index   !<
+
+    LOGICAL, INTENT(OUT) ::  data_to_write  !< returns, if surface data have to be written
 
 
@@ -2372,5 +2422,5 @@
     CALL MPI_ALLREDUCE( lo_nr_val, all_nr_val, numprocs, MPI_INTEGER, MPI_SUM, comm2d, ierr )
     IF ( ft_surf /= -1  .AND.  sm_io%iam_io_pe )  THEN
-       CALL MPI_TYPE_FREE( ft_surf, ierr )    ! if set, free last surface filetype
+       CALL MPI_TYPE_FREE( ft_surf, ierr )    ! If set, free last surface filetype
     ENDIF
 
@@ -2404,5 +2454,5 @@
 
 !
-!-- Actions during read
+!-- Actions during reading
     IF ( rd_flag )  THEN
        IF ( .NOT. ALLOCATED( m_start_index )  )  ALLOCATE( m_start_index(nys:nyn,nxl:nxr)  )
@@ -2422,5 +2472,5 @@
 
 !
-!-- Actions during write
+!-- Actions during writing
     IF ( wr_flag )  THEN
 !
@@ -2502,11 +2552,11 @@
     IMPLICIT NONE
 
-    INTEGER, DIMENSION(2) ::  dims2
-    INTEGER, DIMENSION(2) ::  lize2
-    INTEGER, DIMENSION(2) ::  start2
-
-    INTEGER, DIMENSION(3) ::  dims3
-    INTEGER, DIMENSION(3) ::  lize3
-    INTEGER, DIMENSION(3) ::  start3
+    INTEGER, DIMENSION(2) ::  dims2   !<
+    INTEGER, DIMENSION(2) ::  lize2   !<
+    INTEGER, DIMENSION(2) ::  start2  !<
+
+    INTEGER, DIMENSION(3) ::  dims3   !<
+    INTEGER, DIMENSION(3) ::  lize3   !<
+    INTEGER, DIMENSION(3) ::  start3  !<
 
     TYPE(local_boundaries) ::  save_io_grid  !< temporary variable to store grid settings
@@ -2656,7 +2706,6 @@
 ! Description:
 ! ------------
-!> This subroutine creates file types to access 3d-soil arrays
-!> distributed in blocks among processes to a single file that contains the global arrays.
-!> It is not required for the serial mode.
+!> This subroutine creates file types to access 3d-soil arrays distributed in blocks among processes
+!> to a single file that contains the global arrays. It is not required for the serial mode.
 !--------------------------------------------------------------------------------------------------!
 #if defined( __parallel )
